Grille = {};

function Grille.prerequisitesPresent(specializations)
    return true
end;

function Grille:load(xmlFile)
	local rotationNodePartGrille = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartGrille#index"));
    if rotationNodePartGrille ~= nil then
        self.rotationPartGrille = {};
        self.rotationPartGrille.node = rotationNodePartGrille;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartGrille#minRot"));
        self.rotationPartGrille.minRot = {};
        self.rotationPartGrille.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartGrille.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartGrille.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartGrille#maxRot"));
        self.rotationPartGrille.maxRot = {};
        self.rotationPartGrille.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartGrille.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartGrille.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartGrille.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartGrille#rotTime"), 2)*1000;
        self.rotationPartGrille.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartGrille#touchRotLimit"), 10));
    end;  	
end;

function Grille:delete()
end;

function Grille:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Grille:keyEvent(unicode, sym, modifier, isDown)
	if sym == self.keys.GrilleUP then 
		self.rotationPartGrilleMax = isDown;
	end;
	if sym == self.keys.GrilleDOWN then 
		self.rotationPartGrilleMin = isDown;
	end;
end;

function Grille:update(dt)
   local doRotate = self.rotationPartGrilleMax or self.rotationPartGrilleMin 
	if self.rotationPartGrille ~= nil and doRotate then
        local x, y, z = getRotation(self.rotationPartGrille.node);
        local rot = {x,y,z};
        local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartGrille.maxRot, self.rotationPartGrille.minRot, 3, self.rotationPartGrille.rotTime, dt, not self.rotationPartGrilleMax);
        setRotation(self.rotationPartGrille.node, unpack(newRot));
    end;  
end;

function Grille:draw()
end;
